#!/bin/bash
echo "---------------------------------------------------------------------"
echo "--                 CCN-STIC-826-NEXTCLOUD-PASO 3                   --"
echo "--            SECURIZACIÓN DE PARÁMETROS Y MÓDULOS PHP             --"
echo "--  Antes de ejecutar este script debe asegurarse que los ficheros --"
echo "--       y scripts se encuentran en el directorio /Scripts         --"
echo "---------------------------------------------------------------------"
echo -e "\n"
echo "El script creará una copia de la configuración en el siguiente fichero: "
echo "'/etc/php.ini' con la siguiente nomenclatura '.bak.fecha'"
echo "Se procede a comenzar con la configuración de PHP"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar....."
tiempo=$( date +"%d-%b-%y-%H:%M:%S" )
##########
cp /etc/php.ini /etc/php.ini.bak_$tiempo
sed -i "s/post_max_size = 8M/post_max_size = 50M/" /etc/php.ini
sed -i "s/upload_max_filesize = 2M/upload_max_filesize = 50M/" /etc/php.ini

echo " Debe de evaluar la necesidad de instalación de los siguientes módulos"
echo " PHP-FPM y PHP OPcache"
echo "¿Esta seguro que desea seguir adelante con la instalación? (si/no)? [no]"
echo -e "\n"
read RESPUESTA

if test "$RESPUESTA" = "si";
        then
		echo -e "\n"
                echo "Instalando los módulos de PHP anteriormente descritos..."
				yum -y install php-opcache php-fpm &>/dev/null
				cat > /etc/php.d/10-opcache.ini << EOF
; Habilitar módulo OPcache 
zend_extension=opcache.so
opcache.enable=1
opcache.enable_cli=1
opcache.interned_strings_buffer=8
opcache.max_accelerated_files=10000
opcache.memory_consumption=128
opcache.save_comments=1
opcache.revalidate_freq=1
opcache.blacklist_filename=/etc/php.d/opcache*.blacklist
opcache.huge_code_pages=1
EOF
				echo "Se mostrará a continuación el fichero de configuración"
				echo "/etc/php.d/10-opcache.ini"
				read -p "Pulse ENTER para continuar o Ctrl + C para cancelar....."
				gnome-text-editor /etc/php.d/10-opcache.ini &>/dev/null
				
				
				echo "ahora se reiniciará el servidor Apache2, compruebe que reinicia sin errores"
				systemctl restart httpd
				systemctl status httpd
		else
		echo -e "\n"
                echo "No se instalaron los módulos"
				exit 1
fi

